
(define p 'p)
(define q 'q)
(define r 'r)
(define s 's)
(define (-> p q) `(-> ,p ,q))
(define (& p q) `(& ,p ,q))
(define (^ p q) `(^ ,p ,q))

(test p)				;#f
(test (-> p q))				;#f

; imp intro, forward, backward
(test (-> p p))
(test (-> p (-> p p)))
(test (-> p (-> q p)))
(test (-> p (-> q q)))

; and intro
(test (& (-> p p) (-> q q)))
(test (-> p (& p p)))
(test (-> p (-> q (& p q))))
(test (-> p (-> q (& q p))))

; or intro
(test (^ p (-> q q)))
(test (-> p (^ p q)))
(test (-> p (^ q p)))

; and elim
(test (-> (& p q) p))
(test (-> (& p q) q))
(test (-> (& p q) r))			;#f

; or elim
(test (-> (^ p p) p))
(test (-> (^ p q) p))			;#f
(test (-> (^ p q) (^ p q)))
(test (-> (^ p q) (^ q p)))
(test (-> p (-> (^ q r) (^ (& p q) (& p r)))))

; imp elim
(test (-> (-> p q) (-> p q)))
(test (-> (& (-> p q) p) q))
(test (-> (& p (-> p q)) q))
(test (-> p (-> (-> p q) q)))
(test (-> (& (-> p q) (-> q r)) (-> p r)))
(test (-> (-> p q) (-> (-> q r) (-> p r))))
(test (-> (-> p (& (-> q r) q)) (-> p r)))

;cycles
(test (-> (-> p p) (-> p p)))
(test (-> p (-> (-> p p) p)))       ;Numbers (lambda (zero) (lambda (succ) ?))
(test (-> p (-> (-> (& p p) p) p)))
(test (-> p (-> (-> p p) (-> (-> p p) p))))

;This should have two proofs
(test (-> (-> p q)
	  (-> (-> q s)
	      (-> (-> p r)
		  (-> (-> r s)
		      (-> p s))))))

; Compute candidate definitions of eta, mu, and map for a monad.
(define (monad-test T)
  (test (-> p (T p)))			;eta
  (test (-> (T (T p)) (T p)))		;mu
  (test (-> (-> p q) (-> (T p) (T q))))) ;map

(monad-test (let ((o 'o))		; continuations monad (unique)
	      (lambda (a) (-> (-> a o) o))))

(monad-test (let ((e 'e))		; exceptions (unique)
	      (lambda (a) (^ a e))))

(monad-test (let ((e 1))		; exceptions (not unique)
	      (lambda (a) (^ a e))))

(monad-test (let ((state 's))		; state transformers (not unique)
	      (lambda (a) (-> state (& a state)))))

(monad-test (let ((o 'o) (f 'f))	; backtracking (f = fail)
	      (lambda (a)		; 6 mus, 2 maps
		(-> (& (-> (& a f) o)
		       f)
		    o))))

; co-CCC

(let* ((o 'o)
       (T (lambda (a) (-> (-> a o) o)))   ; continuations monad
       (=> (lambda (a b) (-> a (T b))))
       (+ (lambda (a b) (-> (& (-> a o) (-> b o)) o)))
       (<- (lambda (b c) (& c (-> b o)))))

  (test (=> o p))			;abort
  (test (=> p (+ p q)))			;i1
  (test (=> q (+ p q)))			;i2
  (test (-> (& (=> p r) (=> q r))	;cases
	    (=> (+ p q) r)))
  (test (-> (=> r (+ p q))		;cocurry
	    (=> (<- q r) p)))
  (test (=> r (+ (<- q r) q))))		;pa

